<?php

require_once(dirname(__FILE__) . '/../../../../../plugins/bhLDAPAuthPlugin/lib/adLDAP.php');

/**
 * webservie_sigm_factura_abaco actions.
 *
 * @package    cartera
 * @subpackage webservie_sigm_factura_abaco
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class webservie_sigm_factura_abacoActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Log especifico de procesos completos
        $logPath = sfConfig::get('sf_log_dir') . '/webservice_sigm.log';
        $this->custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));
        $this->custom_logger->info("[webservie_sigm_factura_abaco] Servicio executeList webservie_sigm_factura_abaco.\n");
        $this->custom_logger->info("---BEGIN Logging request--- (Revisar log proceso_completo.log)");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->custom_logger->info("[webservie_sigm_factura_abaco] request[$key] = $value\n");
        }
        $this->custom_logger->info("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->custom_logger->info("[webservie_sigm_factura_abaco] request[$key] = $value");
        }
        $this->custom_logger->info("---END Logging request");

        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        //Codigo de error defecto - 20191001
        $codigo_error = 0;

        $int = 0;
        $service_url = "";
        $entidad_cliente = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $entidad_cliente = $value;
                    }
                }
            }
            $int++;
        }

        //Abrir nueva conexion con la Base de Datos
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);

        $this->parameters = true;
        $parametros = '';

        //Variables por defecto para el registro de log
        $id_tabla = 'null';
        $id_vigencia = 'null';
        $id_cen_op = 'null';
        $id_punto_venta = 'null';
        $id_cia = 1;

        //Variables de registro 
        $num_doc = '';
        $id_anhos = '';
        $id_mae_ter = '';
        $tipo_responsabilidad = '';
        $fecha_facturacion = '';
        $valor_bruto = 0;
        $valor_iva = 0;
        $valor_total = 0;
        $id_caja = '';
        $sesion_caja = '';
        $cajero = '';
        $observaciones = '';
        $productos = '';
        $cantidades = '';
        $valores_uni_bruto = '';
        $valores_uni_iva = '';
        $valores_uni_total = '';
        $id_ts_pc_fp = '';
        $id_bn = '';
        $id_cb = '';
        $num_doc_sop = '';
        $fecha_doc_sop = '';
        $fecha_log = '';
        $termino_proceso = '';
        $id_factura = '';
        $motivo_error = '';
        $sec_factura = '';
        //datos abaco
        $estado_abaco = '';
        $idinvoice_abaco = '';
        $message_abaco = '';
        $successful_abaco = '';
        $idRequest_abaco = '';

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CA_FACTURA_POS');

        //  1- CONSULTAR, 2- ACTUALIZAR, 3 - ADICIONAR, 4 - ELIMINAR, 5 - ANULAR
        $id_ope_bd = 3;
        //id del maestro tercero
        $id_mae_ter_log = 1;
        $usuario = 'admin';
        $comando = 'webservie_sigm_factura_abaco';
        //construir observacion
        $observacion_log = "'Se ingreso a generar factura pos desde servicio webservie_sigm_factura_abaco'";

        //Manejo de errores
        //Variables obligatorias
        $id_vigencia = $id_anhos = date('Y');
        $fecha_facturacion = $fecha_proceso = CN_TABLE::fechaSistema();

        /**
         * Inicio del proceso
         */
        try {

            // Registro de consulta en tabla de log
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion_log . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion_log, $id_punto_venta);

            // Variables de retorno
            $resultado = array();


            /**
             * Verificar acceso a servicio por LDAP - 20191001
             */
            //Para local sofhouse no valida - 20191001
            if ($entidad_cliente != 7) {

                //Variables de configuracion del servidor de conexion LDAP (app.yml)
                $account_suffix = sfConfig::get('app_account_suffix');
                $domain_controllers = sfConfig::get('app_domain_controllers');
                $base_dn = sfConfig::get('app_base_dn');
                $admin_username = sfConfig::get('app_admin_username');
                $admin_password = sfConfig::get('app_admin_password');

                $config = array(
                    'account_suffix' => $account_suffix,
                    'domain_controllers' => array($domain_controllers),
                    'base_dn' => $base_dn,
                    'admin_username' => $admin_username,
                    'admin_password' => $admin_password,
                );

                $adldap = new adLDAP($config);

                if (!isset($request['usuario_web']) || !isset($request['clave_web'])) {
                    //Codigo de error - 20191001
                    $codigo_error = 1;
                    throw new Exception("Falta los parámetros de acceso obligatorios verificar.");
                }

                //Se decodifica la clave - 20200924
                $usuario_web = base64_decode($request['usuario_web']);
                $clave_web = base64_decode($request['clave_web']);
                $authUser = $adldap->authenticate($usuario_web, $clave_web);

                if ($authUser != true) {
                    //Codigo de error - 20191001
                    $codigo_error = 2;
                    throw new Exception("La autenticación de usuario($usuario_web) para el servicio web fallo; favor verificar.");
                }
            }

            /*
             * Verificar parametros - 20190911
             */
            $param_oblig = 'num_doc;id_tipo_doc;id_nat_jur;id_tip_ter;razon_soc;pnombre_snombre_papellido_sapellido;direccion;coddepto;ciudad;email;tipo_responsabilidad;id_punto_venta;valor_bruto;valor_iva;valor_total;productos;cantidades;valores_uni_bruto;valores_uni_iva;valores_uni_total;id_ts_pc_fp;id_bn;id_cb;num_doc_sop;fecha_doc_sop';
            $param_oblig_datos = explode(';', $param_oblig);

            foreach ($param_oblig_datos as $value) {
                if (!isset($request[$value])) {
                    $this->parameters = false;
                    $parametros = $parametros . ';' . $value;
                }
            }

            if (!$this->parameters) {
                $parametros = substr($parametros, 1);
                //Codigo de error - 20191001
                $codigo_error = 3;
                throw new Exception("Falta alguno de los parámetros($parametros) obligatorios verificar.");
            }


            /**
             * Variables obligatorias
             */
            $num_doc = $request['num_doc'];
            $email = $request['email'];

            /**
             * Tipo Responsabilidad - 20200806
             */
            if (isset($request['tipo_responsabilidad'])) {
                $tipo_responsabilidad = $request['tipo_responsabilidad'];
            }

            /**
             * Variables de la factura
             */
            /*
             * CA_FACTURA_POS
              ID_PUNTO_VENTA
              ID_CAJA
              SEC_FACTURA
              ID_MAE_TER
              FECHA_FACTURACION
              VALOR_BRUTO
              VALOR_IVA
              VALOR_TOTAL
              CAJERO
              OBSERVACIONES
             */
            $id_punto_venta = $request['id_punto_venta'];
            $valor_bruto = str_replace(",", ".", $request['valor_bruto']);
            $valor_iva = str_replace(",", ".", $request['valor_iva']);
            $valor_total = str_replace(",", ".", $request['valor_total']);
            $observaciones = 'VENTAS PORTAL WEB';
            if (isset($request['observaciones'])) {
                $observaciones = $request['observaciones'];
            }
            /*
             * CA_FACTURA_PROD
              ID_PRODUCTO
              CANTIDAD
              VALOR_UNI_BRUTO
              VALOR_UNI_IVA
              VALOR_UNI_TOTAL
              REFERENCIA
             */
            $productos = $request['productos'];
            $cantidades = $request['cantidades'];
            $valores_uni_bruto = $request['valores_uni_bruto'];
            $valores_uni_iva = $request['valores_uni_iva'];
            $valores_uni_total = $request['valores_uni_total'];
            $referencia = '';
            if (isset($request['referencia'])) {
                $referencia = $request['referencia'];
            }

            //validar array de productos
            $total_productos = 0;
            $param_productos = explode(';', $productos);
            $param_cantidades = explode(';', $cantidades);
            $param_valores_uni_bruto = explode(';', $valores_uni_bruto);
            $param_valores_uni_iva = explode(';', $valores_uni_iva);
            $param_valores_uni_total = explode(';', $valores_uni_total);

            $cant_produc = count($param_productos);
            for ($i = 0; $i < $cant_produc; $i++) {
                $total_productos += str_replace(",", ".", $param_valores_uni_total[$i]);
            }
            $this->custom_logger->info("total_productos------------------" . $total_productos);

            /*
             * CA_FACTURA_PAGO
              ID_TS_PC_FP
              VALOR
              ID_BN
              ID_CB
              OFICINA
              NUM_DOC
              FECHA_DOC
             */
            $id_ts_pc_fp = $request['id_ts_pc_fp'];
            $valor = str_replace(",", ".", $request['valor_total']);
            $id_bn = $request['id_bn'];
            $id_cb = $request['id_cb'];
            $oficina = 'VENTAS PORTAL WEB';
            if (isset($request['oficina'])) {
                $oficina = $request['oficina'];
            }
            $num_doc_sop = $request['num_doc_sop'];
            $fecha_doc_sop = $request['fecha_doc_sop'];


            /*
             * Verificar tercero por num_doc, sino lo crea
             */
            //sentencia sql
            $sql = <<<EOD
select * from interceros where num_doc = '$num_doc'   
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_ter = CN_TABLE::executeSQL($sql);

            /**
             * Crear tercero
             */
            if (count($resultado_ter) <= 0) {

                /*
                 * TERCERO :: 
                  ID_NAT_JUR
                  ID_TIP_TER
                  ID_TIPO_DOC
                  NUM_DOC
                  PNOMBRE-SNOMBRE-PAPELLIDO-SAPELLIDO
                  RAZON_SOC
                  DIRECCION
                  CIUDAD
                  TELEFONO
                  EMAIL
                  CODDEPTO
                 */
                $id_nat_jur = 'null';
                if (isset($request['id_nat_jur'])) {
                    $id_nat_jur = $request['id_nat_jur'];
                }
                $id_tip_ter = 'null';
                if (isset($request['id_tip_ter'])) {
                    $id_tip_ter = $request['id_tip_ter'];
                }
                $id_tipo_doc = 'null';
                if (isset($request['id_tipo_doc'])) {
                    $id_tipo_doc = $request['id_tipo_doc'];
                }

                /**
                 * PNOMBRE-SNOMBRE-PAPELLIDO-SAPELLIDO=Mario-Andres-Jerez-Quintero
                 */
                $pnombre = '';
                $snombre = '';
                $papellido = '';
                $sapellido = '';
                $pnombre_snombre_papellido_sapellido = '';
                if (isset($request['pnombre_snombre_papellido_sapellido'])) {
                    $pnombre_snombre_papellido_sapellido = $request['pnombre_snombre_papellido_sapellido'];

                    $variables = explode('-', $pnombre_snombre_papellido_sapellido);

                    $pnombre = $variables[0];
                    $snombre = $variables[1];
                    $papellido = $variables[2];
                    $sapellido = $variables[3];
                }

                $razon_soc = '';
                if (isset($request['razon_soc'])) {
                    $razon_soc = str_replace('-', ' ', utf8_encode($request['razon_soc']));
                }
                $direccion = '';
                if (isset($request['direccion'])) {
                    $direccion = utf8_decode($request['direccion']);
                    $direccion = str_replace("'", " ", $direccion); //Quitar comilla simple - 20180713
                    $this->logMessage("Direccion::" . $direccion);
                }
                $ciudad = 'Bogota';
                //Se coloca validacion $request['ciudad'] != '', por si viene vacia - 20160803
                if (isset($request['ciudad']) && $request['ciudad'] != '') {
                    $ciudad = utf8_decode($request['ciudad']);
                }
                $telefono = '';
                if (isset($request['telefono'])) {
                    $telefono = $request['telefono'];
                }
                $coddepto = '';
                if (isset($request['coddepto'])) {
                    $coddepto = $request['coddepto'];
                }

                $id_mae_ter = 0;


                $this->logMessage("Crear tercero");
                $this->custom_logger->info("[webservie_sigm_factura_abaco] Crear tercero");

                //verificar persona para el digito de verificacion}
                $dv = 'null';
                if ($num_doc >= 800000000 && $num_doc <= 999999999) {
                    //sentencia sql
                    $sql = <<<EOD
select digito_verificacion($num_doc) as dv from dual 
EOD;
                    //ejecuta el sql
                    //$this->conn->execute($sql);
                    $resultado = CN_TABLE::executeSQL($sql);
                    $dv = $resultado[0]['dv'];
                }
                if (isset($request['digito_verificacion'])) {
                    $dv = $request['digito_verificacion'];
                }

                /**
                 * Crear registros de tercero tabla INTERCEROS - INTERCEROS_DU - INTERCEROS_DU_DIR
                 * Se valida comilla simple del nombre 20200903::LAVILA
                 */
                $razon_soc_text = str_replace("'", "'|| chr(39) ||'", $razon_soc);
                //sentencia sql
                $sql = <<<EOD
Insert into INTERCEROS (ID_MAE_TER,ID_NAT_JUR,ID_TIP_TER,ID_TIPO_DOC,NUM_DOC,CODIGO,
    RAZON_SOC,CAM_COM,PNOMBRE,SNOMBRE,ESTADO_TER,FECHA_DOC,PAPELLIDO,SAPELLIDO,
        NMATRICULA,NMATRICULAMER,PROFESION,DV,OBJETIVO) 
    values (null,$id_nat_jur,$id_tip_ter,$id_tipo_doc,'$num_doc',null,
        upper('$razon_soc_text'),null,upper('$pnombre'),upper('$snombre'),1,null,upper('$papellido'),upper('$sapellido'),
            null,null,null,$dv,null)  
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);

                //sentencia sql
                $sql = <<<EOD
select * from interceros where num_doc = '$num_doc'   
EOD;
                //ejecuta el sql
                //$this->conn->execute($sql);
                $resultado_ter = CN_TABLE::executeSQL($sql);
                if (count($resultado_ter) > 0) {
                    $id_mae_ter = $resultado_ter[0]['id_mae_ter'];
                } else {
                    $id_mae_ter = 0;
                }

                //sentencia sql                
                $sql = <<<EOD
Insert into INTERCER_DU (ID_MT_UBI,ID_MAE_TER,ID_LOC_DIR,WEB_SITE,MAIL,CONTACTO,
    CARGO_CON,AP_AEREO,MAIL_CON,ID_PAIS,COPDEPTO,CIUDAD) 
    values (null,$id_mae_ter,1,null,'$email',upper('$pnombre $papellido $sapellido'),
        null,null,'$email',49,'$coddepto',upper('$ciudad'))  
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);


                //sentencia sql
                $sql = <<<EOD
select * from INTERCER_DU where id_mae_ter = $id_mae_ter   
EOD;
                //ejecuta el sql
                //$this->conn->execute($sql);
                $resultado_ter = CN_TABLE::executeSQL($sql);
                if (count($resultado_ter) > 0) {
                    $id_mt_ubi = $resultado_ter[0]['id_mt_ubi'];
                } else {
                    $id_mt_ubi = 0;
                }

                //sentencia sql                
                $sql = <<<EOD
Insert into INTERCER_DU_DIR (ID_UBI_DIR,ID_MT_UBI,ID_TIP_DIR,DIRECCION,TEL,FAX,ID_PAIS,CODDEPTO,CIUDAD,ESTADO,PRINCIPAL,CIUDAD_DANE,DEPTO_DANE) 
    values (null,$id_mt_ubi,1,'$direccion','$telefono',null,49,'$coddepto',upper('$ciudad'),1,1,null,null) 
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);

                $this->logMessage("Se creo el tercero");
                $this->custom_logger->info("Se creo el tercero");
            } else {
                $id_mae_ter = $resultado_ter[0]['id_mae_ter'];

                /**
                 * Actualizar datos(telefono,direcion,ciudad) del tercero - 20150318
                 */
                $direccion = '';
                if (isset($request['direccion']) && $request['direccion'] != '') {
                    $direccion = utf8_decode($request['direccion']);
                    $direccion = str_replace("'", " ", $direccion); //Quitar comilla simple - 20180713
                    $this->logMessage("Direccion::" . $direccion);
                }
                $ciudad = 'Bogota';
                //Se coloca validacion $request['ciudad'] != '', por si viene vacia - 20160803
                if (isset($request['ciudad']) && $request['ciudad'] != '') {
                    $ciudad = utf8_decode($request['ciudad']);
                }
                $telefono = '';
                if (isset($request['telefono']) && $request['telefono'] != '') {
                    $telefono = $request['telefono'];
                }
                $coddepto = '';
                if (isset($request['coddepto']) && $request['coddepto'] != '') {
                    $coddepto = $request['coddepto'];
                }

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU where ID_MAE_TER = $id_mae_ter  
EOD;
                //ejecuta el sql
                $resultado_terdu = CN_TABLE::executeSQL($sql);

                //Valida si es crear o actualizar tabla - 20160628
                if (count($resultado_terdu) == 0) {

                    $sql = <<<EOD
Insert into INTERCER_DU (ID_MT_UBI,ID_MAE_TER,ID_LOC_DIR,WEB_SITE,MAIL,CONTACTO,CARGO_CON,AP_AEREO,MAIL_CON,ID_PAIS,COPDEPTO,CIUDAD) 
values (null,'$id_mae_ter','1',null,'$email',null,null,null,null,'49','$coddepto',upper('$ciudad')) 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                } else {

                    $id_mt_ubi = $resultado_terdu[0]['id_mt_ubi'];

                    //sentencia sql                
                    $sql = <<<EOD
update INTERCER_DU set ciudad = nvl('$ciudad',ciudad)                   
where id_mt_ubi = $id_mt_ubi 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                }

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU where ID_MAE_TER = $id_mae_ter  
EOD;
                //ejecuta el sql
                $resultado_terdu = CN_TABLE::executeSQL($sql);

                $id_mt_ubi = $resultado_terdu[0]['id_mt_ubi'];

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU_DIR where ID_MT_UBI = $id_mt_ubi 
EOD;
                //ejecuta el sql
                $resultado_terdudir = CN_TABLE::executeSQL($sql);


                if (count($resultado_terdudir) > 0) {

                    $id_ubi_dir = $resultado_terdudir[0]['id_ubi_dir'];

                    //sentencia sql                
                    $sql = <<<EOD
update INTERCER_DU_DIR set  direccion = nvl('$direccion',direccion) , tel = nvl('$telefono',tel) , ciudad = nvl('$ciudad',ciudad) 
where ID_UBI_DIR = $id_ubi_dir 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                } else {
                    //sentencia sql                
                    $sql = <<<EOD
Insert into INTERCER_DU_DIR (ID_UBI_DIR,ID_MT_UBI,ID_TIP_DIR,DIRECCION,TEL,FAX,ID_PAIS,CODDEPTO,CIUDAD,ESTADO,PRINCIPAL,CIUDAD_DANE,DEPTO_DANE) 
    values (null,$id_mt_ubi,1,'$direccion','$telefono',null,49,'$coddepto',upper('$ciudad'),1,1,null,null) 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                }
            }

            //Se valida para que actualice campo de pnombre y papellido, segun fecha de razon soc si no tiene nombre - 20181121
            //sentencia sql                
            $sql = <<<EOD
update interceros 
set pnombre = substr(razon_soc, 1, instr(razon_soc, ' ') - 1),
    papellido = substr(razon_soc, instr(razon_soc, ' ') + 1)
where
id_mae_ter = $id_mae_ter
and (pnombre is null or papellido is null) 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            //verificar persona para el digito de verificacion - 20191223
            if ($num_doc >= 800000000 && $num_doc <= 999999999) {
                //sentencia sql                
                $sql = <<<EOD
update interceros 
set dv = digito_verificacion('$num_doc')
where
id_mae_ter = $id_mae_ter
and dv is null 
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);
            }

            $this->logMessage("id_mae_ter :: " . $id_mae_ter);
            $this->custom_logger->info("id_mae_ter :: " . $id_mae_ter);

            /**
             * Tipo Responsabilidad, generar registro del tercero - 20200806
             */
            if (isset($request['tipo_responsabilidad'])) {
                $this->logMessage("tipo_responsabilidad :: " . $tipo_responsabilidad);
                $this->custom_logger->info("tipo_responsabilidad :: " . $tipo_responsabilidad);

                /**
                 * validar INTERCER_DT
                 */
                //sentencia sql
                $sql = <<<EOD
select * from INTERCER_DT where id_mae_ter = $id_mae_ter   
EOD;
                //ejecuta el sql
                $resultado_dt = CN_TABLE::executeSQL($sql);
                if (count($resultado_dt) > 0) {
                    $id_inf_tri = $resultado_dt[0]['id_inf_tri'];
                } else {

                    //sentencia sql                
                    $sql = <<<EOD
INSERT INTO INTERCER_DT (ID_INF_TRI,ID_MAE_TER,CIIU_PRIN,CIIU_SEC,CIIU_TER,CIIU_CUA,PATH_RUP,PATH_DOC) 
    VALUES (null,'$id_mae_ter',NULL,NULL,NULL,NULL,NULL,NULL) 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);

                    //sentencia sql
                    $sql = <<<EOD
select * from INTERCER_DT where id_mae_ter = $id_mae_ter   
EOD;
                    //ejecuta el sql
                    $resultado_dt = CN_TABLE::executeSQL($sql);
                    if (count($resultado_dt) > 0) {
                        $id_inf_tri = $resultado_dt[0]['id_inf_tri'];
                    }
                }

                //divide por caracter ;
                $tipo_responsabilidades = explode(';', $tipo_responsabilidad);

                foreach ($tipo_responsabilidades as $value_tipo) {

                    //verifica codigo del tipo
                    //sentencia sql
                    $sql = <<<EOD
SELECT
    *
FROM ts_reg_tri
where
codigo_dian = '$value_tipo'   
EOD;
                    //ejecuta el sql
                    $resultado_reg = CN_TABLE::executeSQL($sql);
                    if (count($resultado_reg) > 0) {

                        $id_reg_tri = $resultado_reg[0]['id_reg_tri'];

                        //verifica res_tri
                        //sentencia sql
                        $sql = <<<EOD
SELECT
    *
FROM ts_res_tri
where
id_inf_tri = $id_inf_tri
and id_reg_tri = $id_reg_tri  
EOD;
                        //ejecuta el sql
                        $resultado_res = CN_TABLE::executeSQL($sql);
                        if (count($resultado_res) <= 0) {

                            //sentencia sql                
                            $sql = <<<EOD
Insert into TS_RES_TRI (ID_RES_TRI,AUTORETENEDOR,ID_REG_TRI,ID_TIP_RES,ID_INF_TRI) 
    values (null,(case when '$value_tipo' = 'O-15' then 1 else 0 end),'$id_reg_tri','1','$id_inf_tri')
EOD;
                            //ejecuta el sql
                            $this->conn->execute($sql);
                        }
                    }
                }
            }//fin tipo responsabilidad


            /*
             * Validar valor total de la factura
             */
            if ($valor_total != $total_productos) {
                //Codigo de error - 20200810
                $codigo_error = 10;
                throw new Exception("EL valor de la factura($valor_total) no coincide con el total de los productos($total_productos).");
            }

            $this->logMessage("Validar valor total de la factura");

            /**
             * Validar num_doc_sop de la forma de pago
             * Validar estado de la factura - 20170705
             */
            //sentencia sql
            $sql = <<<EOD
select 
aba.estado_abaco,
aba.idinvoice,
aba.successful_txt,
aba.message,
aba.idrequest,
pag.* 
from ca_factura_pago pag

left join ca_factura_pos pos
on pos.id_factura = pag.id_factura

left join ca_factura_abaco aba
on pag.id_factura = aba.id_factura

where 
pos.estado = 1
and pag.id_ts_pc_fp = $id_ts_pc_fp and pag.num_doc = '$num_doc_sop'   
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_fp = CN_TABLE::executeSQL($sql);

            if (count($resultado_fp) > 0) {

                /**
                 * Reprocesar el llamado a abaco, de ser invalido - 20190226
                 */
                $id_factura = $resultado_fp[0]['id_factura'];

                $estado_abaco = $resultado_fp[0]["estado_abaco"];
                $idinvoice_abaco = $resultado_fp[0]["idinvoice"];
                $message_abaco = $resultado_fp[0]["message"];
                $successful_abaco = $resultado_fp[0]["successful_txt"];
                $idRequest_abaco = $resultado_fp[0]["idRequest"];

                /**
                 * Validacion de estado abaco, solo generara llamado si no esta correcto - 20200806
                 */
                if ($estado_abaco == 0) {

                    $array_abaco = $this->llamadoAbaco($id_factura);

                    $idinvoice_abaco = $array_abaco["idinvoice"];
                    $message_abaco = $array_abaco["message"];
                    $successful_abaco = $array_abaco["successful"];
                    $idRequest_abaco = $array_abaco["idRequest"];
                }

                if ($successful_abaco == 'false') {
                    $message_abaco = "Se intento reprocesar llamado a Abaco pero no hubo respuesta o genero el mensaje: " . $message_abaco . "";
                }

                $mensaje = "El numero $num_doc_sop del registro del pago, para la forma de pago seleccionada ya existe; favor verirficar.";

                $this->logMessage($mensaje);
                $this->custom_logger->info($mensaje);

                //Codigo de error - 20200810
                $codigo_error = 6;
                throw new Exception("El PIN($num_doc_sop) para el $id_anhos del registro de causación ya existe; favor verificar.");
            }

            $this->logMessage("Validar num_doc_sop de la forma de pago");

            /*
             * CA_FACTURA_POS
             */
            //$id_punto_venta = 102;
            //sentencia sql
            $sql = <<<EOD
select * from ca_consecutivo_caja where id_punto_venta = $id_punto_venta   
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_punt = CN_TABLE::executeSQL($sql);

            $id_caja = $resultado_punt[0]['id_caja'];
            $sec_factura = $resultado_punt[0]['consec_fac'] + 1;
            $sesion_caja = $resultado_punt[0]['sesion_caja'];

            //Actualiza el consecutivo, este se vuelve a modificar al insertar la factura_pos - 20160223      
            $sql = <<<EOD
update ca_consecutivo_caja set consec_fac = $sec_factura 
where id_punto_venta = $id_punto_venta and id_caja = $id_caja 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            //sentencia sql
            $sql = <<<EOD
select 
id_estado_caja, 
id_punto_venta
id_caja,
fecha_estado,
sesion,
cajero,
estado as estado_num
from ca_estado_caja 
where id_punto_venta = $id_punto_venta and id_caja = $id_caja                                 
order by fecha_estado desc, sesion desc   
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_est = CN_TABLE::executeSQL($sql);

            if (count($resultado_est) <= 0 || $resultado_est[0]['estado_num'] == 0) {
                //Codigo de error - 20200810
                $codigo_error = 27;
                throw new Exception("Por favor verificar el estado de la caja, debe estar en estado cerrada.");
            }


            $id_estado_caja = $resultado_est[0]['id_estado_caja'];
            $cajero = $resultado_est[0]['cajero'];

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD HH24:MI:SS" 
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'Se van a registrar detalles de la factura en CA_LOG_FACTURA'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


            /**
             * Incidente #3702 - 20160617
             * Si la fecha de soporte no es en el mes de proceso, se coloca la fecha de proceso, sysdate,
             * se coloca en las observaciones la fecha de soporte - 20160721
             * Se cambia para que tome la fecha actual ya que en ABACO si quedan con el registro actual, y asi no tener diferencia ( and 1!=1 )- 200190829
             */
            //sentencia sql                
            $sql = <<<EOD
Insert into CA_FACTURA_POS (ID_FACTURA,ID_ANHOS,ID_PUNTO_VENTA,ID_CAJA,SEC_FACTURA,ID_MAE_TER,
    FECHA_FACTURACION,VALOR_BRUTO,VALOR_IVA,VALOR_TOTAL,CAJERO,OBSERVACIONES,ESTADO,FECHA_ANU,MOTIVO_ANU,ID_ESTADO_CAJA,VALOR_RETEN,EMAIL_WEB,TIPO_RESPONSABILIDAD) 
    values (null,to_char(sysdate,'yyyy'),$id_punto_venta,$id_caja,$sec_factura,$id_mae_ter,
        (select case when to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'mm') = to_char(sysdate,'mm') 
            and to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'yyyy') = to_char(sysdate,'yyyy') and 1!=1  
                then to_date('$fecha_doc_sop','yyyy-mm-dd') else sysdate end as fecha from dual),
            $valor_bruto,$valor_iva,$valor_total,$cajero,
                case when to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'mm') = to_char(sysdate,'mm') 
            and to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'yyyy') = to_char(sysdate,'yyyy') 
                then '$observaciones' else '$observaciones, Se reprocesa al mes actual de proceso fecha de soporte: $fecha_doc_sop' end ,1,null,null,$id_estado_caja,
                    0,'$email','$tipo_responsabilidad') 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            //sentencia sql
            /*
             * Se adiciona filtro de sec_factura, 
             * para traer el registro que corresponde a al factura ingresada anteriormente - 20160223
             */
            $sql = <<<EOD
select * from ca_factura_pos
where id_punto_venta = $id_punto_venta and id_caja = $id_caja 
    and id_mae_ter = $id_mae_ter and sec_factura = $sec_factura
order by fecha_facturacion desc    
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_facpos = CN_TABLE::executeSQL($sql);

            $id_factura = $resultado_facpos[0]['id_factura'];
            $this->custom_logger->info("id_factura::" . $id_factura);


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            /*
             * CA_FACTURA_PROD
             */
            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'Registro del producto en CA_FACTURA_PROD, id_factura::$id_factura'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


            //validar array de productos
            if (count($param_productos) != count($param_cantidades) || count($param_productos) != count($param_valores_uni_bruto) || count($param_productos) != count($param_valores_uni_iva) || count($param_productos) != count($param_valores_uni_total)) {

                //Codigo de error - 20200810
                $codigo_error = 28;
                throw new Exception("La cantidad de registros para los detalles de los productos no coincide.");
            }

            for ($i = 0; $i < $cant_produc; $i++) {

                $id_producto = $param_productos[$i];
                $cantidad = $param_cantidades[$i];
                $valor_uni_bruto = str_replace(",", ".", $param_valores_uni_bruto[$i]);
                $valor_uni_iva = str_replace(",", ".", $param_valores_uni_iva[$i]);
                $valor_uni_total = str_replace(",", ".", $param_valores_uni_total[$i]);


                //sentencia sql                
                $sql = <<<EOD
Insert into CA_FACTURA_PROD (ID_FACTURA_PROD,ID_FACTURA,ID_PRODUCTO,CANTIDAD,VALOR_UNI_BRUTO,VALOR_UNI_IVA,VALOR_UNI_TOTAL,REFERENCIA) 
    values (null,$id_factura,$id_producto,$cantidad,$valor_uni_bruto,$valor_uni_iva,$valor_uni_total,'$referencia') 
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);
            }



            $this->custom_logger->info("Termino CA_FACTURA_PROD");

            /*
             * CA_FACTURA_PAGO
             */
            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'Registro del pago en CA_FACTURA_PAGO, id_factura::$id_factura'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

            /**
             * Se agrega tipo de tramforma de pago en la oficina - 20160617
             */
            if ($id_ts_pc_fp == 21) {
                $oficina = $oficina . ' - PSE';
            } elseif ($id_ts_pc_fp == 22) {
                $oficina = $oficina . ' - CODIGO BARRAS';
            }

            //sentencia sql                
            $sql = <<<EOD
Insert into CA_FACTURA_PAGO (ID_FACTURA_PAGO,ID_FACTURA,ID_TS_PC_FP,VALOR,ID_BN,ID_CB,OFICINA,NUM_DOC,FECHA_DOC) 
    values (null,$id_factura,$id_ts_pc_fp,$valor,$id_bn,$id_cb,'$oficina','$num_doc_sop',to_date('$fecha_doc_sop','yyyy-mm-dd')) 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            $this->custom_logger->info("Termino CA_FACTURA_PAGO");


            /**
             * Incidente #10372, Generar registro detalle ABACO - 20181114
             */
            $sql = <<<EOD
Insert into CA_FACTURA_ABACO (ID_FACTURA,USUARIO,FECHA_LOG,IDINVOICE,MESSAGE,SUCCESSFUL_TXT,IDREQUEST,
    ESTADO_ABACO,FECHA_ABACO,ESTADO_CORREO,FECHA_CORREO) 
values ('$id_factura','websafi',sysdate,'$sec_factura',null,'false',null,
    '0',null,'0',null)
EOD;

            $this->conn->execute($sql);


            /**
             * Crear Referencia SIGM
             */
            $this->custom_logger->info("Crear Referencia SIGM");

            //sentencia sql
            $sql = <<<EOD
Insert into CA_FACTURA_POS_SIGM values ( $id_factura, 1)
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);
            $this->logMessage("[webservie_sigm_factura_abaco] SQL de las referencias SIGM de la factura: " . $sql);


            /*
             * Revalidar secuencia debito creada - 20190911
             */
            $this->custom_logger->info("Revalidar secuencia factura creada");
            //sentencia sql
            $sql = <<<EOD
select
*
from CA_FACTURA_POS
where
id_anhos = $id_anhos
AND id_punto_venta = $id_punto_venta
AND sec_factura = $sec_factura 
EOD;

            //ejecuta el sql
            $result = CN_TABLE::executeSQL($sql);

            //validar si hay registro de secuencia debito
            if (count($result) > 1) {
                //Codigo de error - 20191001
                $codigo_error = 7;
                throw new Exception("Ya existe la secuencia($sec_factura) para la obligación.");
            }


            //Crear registro de error
            $sql = <<<EOD
INSERT INTO CA_WEBSEVICE_FACTURA_ABACO (ID_WEBSEVICE_FACTURA_ABACO,ID_ANHOS,ID_PUNTO_VENTA,ID_MAE_TER,TIPO_RESPONSABILIDAD,
    FECHA_FACTURACION,VALOR_BRUTO,VALOR_IVA,VALOR_TOTAL,ID_CAJA,CONSEC_FAC,SESION_CAJA,CAJERO,OBSERVACIONES,
        PRODUCTOS,CANTIDADES,VALORES_UNI_BRUTO,VALORES_UNI_IVA,VALORES_UNI_TOTAL,
            ID_TS_PC_FP,ID_BN,ID_CB,NUM_DOC_SOP,FECHA_DOC_SOP,FECHA_LOG,
                TERMINO_PROCESO,ID_FACTURA,MOTIVO_ERROR) 
VALUES (null,'$id_anhos',$id_punto_venta,'$id_mae_ter','$tipo_responsabilidad',
    TO_DATE('$fecha_facturacion','YYYY-MM-DD'),'$valor_bruto','$valor_iva','$valor_total','$id_caja','$sec_factura','$sesion_caja','$cajero','$observaciones',
        '$productos','$cantidades','$valores_uni_bruto','$valores_uni_iva','$valores_uni_total',
            '$id_ts_pc_fp','$id_bn','$id_cb','$num_doc_sop',TO_DATE('$fecha_doc_sop','YYYY-MM-DD'),sysdate,
                '1','$id_factura','') 
EOD;
            $this->conn->execute($sql);

            /**
             * COMMIT
             */
            //throw new Exception("Prueba COMMIT");
            $this->conn->commit();
            $mensaje = 'Proceso terminado exitoso.';
            $this->logMessage("COMMIT " . $mensaje);
            $this->custom_logger->info("COMMIT " . $mensaje);


            /**
             * Incidente #10372, Llamado a servicio ABACO - 20181114
             */
            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'INICIO LLAMADO ABACO'";
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


            $array_abaco = $this->llamadoAbaco($id_factura);

            $idinvoice_abaco = $array_abaco["idinvoice"];
            $message_abaco = $array_abaco["message"];
            $successful_abaco = $array_abaco["successful"];
            $idRequest_abaco = $array_abaco["idRequest"];

            if ($successful_abaco == 'false') {
                $message_abaco = "Se intento reprocesar llamado a Abaco pero no hubo respuesta o genero el mensaje: " . $message_abaco . "";
            }

            $this->logMessage("[FACTURA_PORTAL_ABACO] Fin llamado a servicio ABACO.");


            /**
             * Respuesta servicio
             */
            $this->status = 0;
            //$this->mensajeError = $mensaje;
            $this->list_data = array(
                array(
                    'mensaje' => $mensaje,
                    'id_factura' => $id_factura,
                    'id_anhos' => $id_vigencia,
                    'sec_factura' => $sec_factura,
                    'servicio' => 'webservie_sigm_factura_abaco',
                    'modulo' => 'CARTERA',
                    'idinvoice_abaco' => $idinvoice_abaco,
                    'message_abaco' => $message_abaco,
                    'successful_abaco' => $successful_abaco
                )
            );


            /**
             * GENERAR MOVIMIENTO BANCO - 20150210
             */
            $this->logMessage("INICIO GENERAR MOVIMIENTO BANCO");
            $this->custom_logger->info("INICIO GENERAR MOVIMIENTO BANCO");

            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'INICIO GENERAR MOVIMIENTO BANCO'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


            //Valida que aplica banco
            //sentencia sql
            $sql = <<<EOD
select * from ts_pc_fp
where id = $id_ts_pc_fp
and aplica_bn = 1 
EOD;

            //ejecuta el sql
            $resultado = CN_TABLE::executeSQL($sql);
            $aplica_banco = false;
            if (count($resultado) > 0) {
                $aplica_banco = true;
            }

            if ($aplica_banco) {
                $this->logMessage("GENERAR MOVIMIENTO BANCO");
                $this->custom_logger->info("GENERAR MOVIMIENTO BANCO");

                /*
                 * Traer datos de la factura
                 */
                //sentencia sql
                $sql = <<<EOD
select * from ca_factura_pos where  id_factura = $id_factura 
EOD;

                //ejecuta el sql
                $resultado = CN_TABLE::executeSQL($sql);
                if (count($resultado) > 0) {
                    $id_factura = $resultado[0]['id_factura'];
                    $id_anhos = $resultado[0]['id_anhos'];
                    $id_punto_venta = $resultado[0]['id_punto_venta'];
                    $sec_factura = $resultado[0]['sec_factura'];
                    $id_mae_ter = $resultado[0]['id_mae_ter'];
                    $fecha_facturacion = $resultado[0]['fecha_facturacion'];
                    $cajero = $resultado[0]['cajero'];
                }


                $url = $service_url;
                $url = $url . 'movimiento_banco_pos/list.json?PARAM_id_mod=12&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946';

                $params = array(
                    'id_factura' => $id_factura,
                    'id_anhos' => $id_anhos,
                    'id_punto_venta' => $id_punto_venta,
                    'sec_factura' => $sec_factura,
                    'id_mae_ter' => $id_mae_ter,
                    'fecha_facturacion' => $fecha_facturacion,
                    'cajero' => $cajero,
                    'tag_portal_web' => 1
                );

                if ($service_url != null) {
                    CN_TABLE::curlPostAsync($url, $params);
                }
                $this->logMessage("FIN MOVBANC FACTURA POS");
            } else {
                $this->logMessage("[webservie_sigm_factura_abaco] No aplica bancos.");
            }
            /**
             * FIN MOVBANC
             */
            $this->logMessage("FIN GENERAR MOVIMIENTO BANCO");

            /**
             * Llamado INTERFAZ CONTABLE - 20190830
             * Se coloca al final al hacer COMMIT de todo el debito y credito - 20170906
             */
            $this->logMessage("INICIO INTERFAZ CONTABLE FACTURA POS");

            $url = $service_url;
            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
            //variables del debito
            //$fecha_proceso = $fecha_sistema;
            $id_mae_ter = 946;
            $mov_ejecutado = "Factura-.-POS";

            $params = array(
                'fecha_proceso' => $fecha_proceso,
                'id_mae_ter' => $id_mae_ter,
                'mov_ejecutado' => $mov_ejecutado,
                'id_movimiento' => $id_factura,
                'tag_portal_web' => '1' //facturas portal web - validar el retorno del json
            );

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }

            $this->logMessage("FIN INTERFAZ CONTABLE FACTURA POS");
        } catch (Exception $e) {

            //rollback de todas las transacciones en caso de que ocurra algun error
            $this->conn->rollback();

            $mensaje = "[webservie_sigm_factura_abaco] ROLLBACK ERROR al Generar la factura. !!!";
            $this->custom_logger->info($mensaje);
            $this->custom_logger->info("state 1");
            $this->custom_logger->info("Code " . $e->getCode());
            $this->custom_logger->info("Message " . $e->getMessage());

            $this->status = 1;
            //$this->mensajeError = $mensaje;
            $this->list_data = array(
                array(
                    'code' => $e->getCode(),
                    'mensaje' => $e->getMessage(),
                    'servicio' => 'webservie_sigm_factura_abaco',
                    'modulo' => 'CARTERA',
                    'codigo_error' => $codigo_error,
                    'idinvoice_abaco' => $idinvoice_abaco,
                    'message_abaco' => $message_abaco,
                    'successful_abaco' => $successful_abaco
                )
            );

            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_tabla = 'null';
            $id_ope_bd = 3;
            $observacion_log = "'Se termino el proceso de webservie_sigm_factura_abaco, se generaron errores en el proceso de creación.'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion_log . ".\n");

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion_log, $id_punto_venta);

            //Se cambian ' por chr(39), para no dañar el insert del log - 20161202            
            //$error_log = $mensaje . ' error message: ' . $e->getMessage() . ' code: ' . $e->getCode();
            $error_log = $mensaje . ' error message: ' . str_replace("'", "'|| chr(39) ||'", $e->getMessage()) . ' code: ' . $e->getCode();
            $error_log = substr($error_log, 1, 4000);

            //Crear registro de error
            $sql = <<<EOD
INSERT INTO CA_WEBSEVICE_FACTURA_ABACO (ID_WEBSEVICE_FACTURA_ABACO,ID_ANHOS,ID_PUNTO_VENTA,ID_MAE_TER,TIPO_RESPONSABILIDAD,
    FECHA_FACTURACION,VALOR_BRUTO,VALOR_IVA,VALOR_TOTAL,ID_CAJA,CONSEC_FAC,SESION_CAJA,CAJERO,OBSERVACIONES,
        PRODUCTOS,CANTIDADES,VALORES_UNI_BRUTO,VALORES_UNI_IVA,VALORES_UNI_TOTAL,
            ID_TS_PC_FP,ID_BN,ID_CB,NUM_DOC_SOP,FECHA_DOC_SOP,FECHA_LOG,
                TERMINO_PROCESO,ID_FACTURA,MOTIVO_ERROR) 
VALUES (null,'$id_anhos',$id_punto_venta,'$id_mae_ter','$tipo_responsabilidad',
    TO_DATE('$fecha_facturacion','YYYY-MM-DD'),'$valor_bruto','$valor_iva','$valor_total','$id_caja','$sec_factura','$sesion_caja','$cajero','$observaciones',
        '$productos','$cantidades','$valores_uni_bruto','$valores_uni_iva','$valores_uni_total',
            '$id_ts_pc_fp','$id_bn','$id_cb','$num_doc_sop',TO_DATE('$fecha_doc_sop','YYYY-MM-DD'),sysdate,
                '0','$id_factura','$error_log') 
EOD;
            $this->conn->execute($sql);


            /**
             * COMMIT
             */
            $this->conn->commit();

            /**
             * Envio de correo de error - 20190911
             */
            $this->custom_logger->info("Envio de correo de error inicio ");

            $url = $service_url . "webservice_envio_correo/list.json";

            $email_destino = sfConfig::get('app_email_destino');

            $recipients = $email_destino . ';' . 'Admin';

            //Varios pagos para n debitos - 20200731::LAVILA
            $body = <<<EOD
<br/>
Se envia correo por fallo de webservie_sigm_factura_abaco; num_doc_sop($num_doc_sop) de fecha($fecha_doc_sop) y valor_total($valor_total).                                       
<br/> <br/> 
Error: 
<br/> <br/> 
$error_log
<br/> 
EOD;

            $params = array(
                'user_from' => 'webservice',
                'recipients' => $recipients,
                'asunto' => 'Error webservie_sigm_factura_abaco',
                'body' => $body
            );

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }

            $this->custom_logger->info("Envio de correo de error fin");
        }
    }

    /**
     * Executes list action construcción
     *
     * @param sfRequest $request A request object
     */
    public function executeList0(sfWebRequest $request) {

        $this->status = 1;
        $this->list_data = array(
            array(
                'code' => 0,
                'mensaje' => 'Servicio en construcción.',
                'servicio' => 'webservie_sigm_factura_abaco',
                'modulo' => 'CARTERA'
            )
        );
    }

    /**
     * Se hace llamado a Abaco y se envia Email - 20181114
     * @param type $id_factura
     */
    public function llamadoAbaco($id_factura = null) {

        $id_factura_filtro = $id_factura;

        //Log especifico de procesos completos - 20160527
        $logPath = sfConfig::get('sf_log_dir') . '/factura_portal_abaco.log';
        $this->custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));

        $this->custom_logger->info("----------------------------------------BEGIN llamadoAbaco. id_factura::" . $id_factura);
        $this->logMessage("----------------------------------------BEGIN llamadoAbaco. id_factura::" . $id_factura);


        $id_tabla = $id_factura;
        $id_vigencia = 'null';
        $id_cen_op = 'null';
        $id_cia = 'null';

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CA_FACTURA_ABACO');

        //  1- CONSULTAR, 2- ACTUALIZAR, 3 - ADICIONAR, 4 - ELIMINAR, 5 - ANULAR
        $id_ope_bd = 3;
        //id del maestro tercero
        $id_mae_ter_log = 1;
        $usuario = 'admin';
        $comando = 'factura_portal_abaco';
        //construir observacion
        $observacion = "'Se ingreso a generar llamadoAbaco.'";

        $id_punto_venta = '102';

        CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

        try {

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('url_abaco' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $url_abaco = $value;
                        }
                    }
                }
                if ('ipServidorCorreo' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $ipServidorCorreo = $value;
                        }
                    }
                }
                if ('correoEnvio' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $correoEnvio = $value;
                        }
                    }
                }
                $int++;
            }


            //valores por defecto
            $message = '';
            $successful = 'false';
            $idrequest = '';
            $idInvoice = '';

            if (!is_null($id_factura_filtro)) {

                $whereFactura = 'and tab0.id_factura = ' . $id_factura_filtro;
                $idInvoice = $id_factura_filtro;
            }

            /**
             * For de ca_facturas_abaco sin procesar para el estado_abaco en 0
             * Se coloca validación para cuando no tiene nombre o apellido - 20190618
             * Se valida en el nombre del tercero las comillas dobles - 20190628
             * Incidente #17555 - 20200604::LAVIA
             * Pago de mas de un producto - 20200810::LAVILA
             */
            $sql = <<<EOD
select distinct
                    
tab0.*,
pos.sec_factura,
pos.observaciones,
DECODE(ter.id_tip_ter, 1, 2, 2, 1) as id_tip_ter,
ter.num_doc,
DECODE(ter.id_tipo_doc, 1,13, 26,22, 27,11, 28,12, 29,31, 31,41, 81,31) as id_tipo_doc,
ter.dv,

upper(nvl(ter.direccion,'NA')) as direccion,
upper(ter.ciudad) as ciudad,
upper(nvl(dep.descripcion,11)) as departamento,
nvl(dep.coddepto,11) as coddepto,
upper( nvl(mun.codmun_text, nvl(mundep.codmun_text, case when dep.coddepto is null then '11001' else dep.coddepto||'001' end ) ) ) as codmun_text,
upper(replace(ter.razon_soc,'"','')) as razon_soc,
case when DECODE(ter.id_tip_ter, 1, 2, 2, 1) = 2 and ter.pnombre is null then upper(replace(ter.razon_soc,'"','')) else upper(replace(ter.pnombre,'"','')) end as pnombre,
upper(replace(ter.snombre,'"','')) as snombre,
case when DECODE(ter.id_tip_ter, 1, 2, 2, 1) = 2 and ter.papellido is null then upper(replace(ter.razon_soc,'"','')) else upper(replace(ter.papellido,'"','')) end as papellido,
ter.tel,
nvl( pos.email_web, nvl(ter.mail,ter.mail_con) ) as mail,

/*
upper(produc.descripcion) as producto,
prod.valor_uni_bruto,
prod.valor_uni_iva,  
prod.valor_uni_total,          
prod.valor_uni_bruto - prod.valor_uni_iva as valorsiniva_uni,          
prod.cantidad as cantidad,
prod.por_iva as por_iva, 
    
produc.codigo,
*/                    
                    
to_char(pos.fecha_facturacion,'dd/mm/yyyy') as fecha_facturacion,
upper(caj.prefijo || ' - ' || caj.ubicacion) as caja,
upper(bn.descripcion) as banco,
cb.numero_cuenta as cuenta,
upper(fp.descripcion) as tipo_pago,
upper(pag.oficina) as oficina,
pag.num_doc as pin,

pos.valor_total - pos.valor_iva as valorsiniva,
pos.valor_iva,
pos.valor_total,
upper(numero_a_texto(pos.valor_total)) as valor_total_text,
                    
nvl(DECODE(fp.id, 21, 3, 22, 42),1) as payment_code,

ter.id_mae_ter,
nvl(tipores.codigo_dian,'"R-99-PN"') as codigo_dian                 

from ca_factura_abaco tab0

left join ca_factura_pos pos
on pos.id_factura = tab0.id_factura

left join ca_caja caj
on caj.id_caja = pos.id_caja

left join ca_factura_prod prod
on pos.id_factura = prod.id_factura

left join ca_producto produc
on produc.id_producto = prod.id_producto

left join ca_factura_pago pag
on pos.id_factura = pag.id_factura

left join ts_pc_fp fp
on fp.id = pag.id_ts_pc_fp

left join ts_bn bn
on bn.id_bn = pag.id_bn

left join ts_cb cb
on cb.id_cb = pag.id_cb

left join interceros_du_dir_v ter
on ter.id_mae_ter = pos.id_mae_ter

left join departamento dep
on dep.coddepto = ter.copdepto

left join municipios mundep
on mundep.depto = dep.id_depto
and upper(mundep.municipio) = upper(ter.ciudad)

left join municipios mun
on mun.codmun = ter.codmun

left join(
    
    SELECT
    ter.id_mae_ter,
    LISTAGG( '"' || reg.codigo_dian || '"', ', ') WITHIN GROUP (ORDER BY reg.codigo_dian) as codigo_dian,
    LISTAGG(reg.descripcion, ';') WITHIN GROUP (ORDER BY reg.codigo_dian) as descripcion
    
    FROM (
    
        select distinct
        id_reg_tri,
        id_inf_tri
        from ts_res_tri     
    )tsreg
    
    left join ts_reg_tri reg
    on reg.id_reg_tri = tsreg.id_reg_tri
    
    left join intercer_dt terdt
    on tsreg.id_inf_tri = terdt.id_inf_tri
    
    left join interceros ter
    on ter.id_mae_ter = terdt.id_mae_ter
    
    where
    reg.codigo_dian is not null
    
    group by
    ter.id_mae_ter

)tipores
on tipores.id_mae_ter = ter.id_mae_ter

where
tab0.estado_abaco = 0 
and tab0.id_factura is not null 
$whereFactura 

order by
tab0.fecha_log                 
EOD;

            //ejecuta el sql
            $resultado = CN_TABLE::executeSQL($sql);
            foreach ($resultado as $value) {

                $id_factura = $value['id_factura'];

                $this->custom_logger->info("Procesar el llamadoAbaco id_factura: " . $id_factura);
                $this->logMessage("Procesar el llamadoAbaco id_factura: " . $id_factura);

                $sec_factura = $value['sec_factura'];
                $observaciones = $value['observaciones'];
                $id_tip_ter = $value['id_tip_ter'];
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $dv = $value['dv'];
                $direccion = $value['direccion'];
                $direccion = str_replace('"', '', $direccion);
                $ciudad = $value['ciudad'];
                $departamento = $value['departamento'];
                $coddepto = $value['coddepto'];
                $codmun_text = $value['codmun_text'];
                $razon_soc = $value['razon_soc'];
                $pnombre = $value['pnombre'];
                $snombre = $value['snombre'];
                $papellido = $value['papellido'];
                $tel = $value['tel'];
                $mail = $value['mail'];

                $codigo = $value['codigo'];
                $fecha_facturacion = $value['fecha_facturacion'];
                $caja = $value['caja'];
                $banco = $value['banco'];
                $cuenta = $value['cuenta'];
                $tipo_pago = $value['tipo_pago'];
                $oficina = $value['oficina'];
                $pin = $value['pin'];

                $valorsiniva = $value['valorsiniva'];
                $valor_iva = $value['valor_iva'];
                $valor_total = $value['valor_total'];
                $valor_total_text = $value['valor_total_text'];

                /** Ejemplo de JSON - ABACO
                  {
                  "username" : "adm_anm@yopmail.com",				//[Usuario del ANM previamente creado en la plataforma. Este usuario cambia de ambiente de producción a ambiente de pruebas]
                  "password" : "G+AiJ1Cq84iauVtdWTuhLk/xBGR0cC1rR3n0tScwWyM=",      //[Contraseña de acceso asociado al usuario - SHA256 codificada Base 64 de la contraseña registrada en la plataforma]
                  "objectType" :0,                                                  //[FACTURA(0), NOTA_CREDITO(1), NOTA_DEBITO(2)]
                  "invoiceIdType" :1,						//[FACTURA_DE_VENTA(0), FACTURA_DE_COMPRA_VENTA(1)]
                  "idRange" :174,							//[Identificador del rango de facturación registrado en la plataforma Ábaco. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "idObject" :"4",							//[Identificador de la Factura generado por la plataforma WebSafi]
                  "idInvoiceType" :120,						//[Identificador de la plantilla PDF a utilizar. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "idNoteType" : null,						//[Identificador de la plantilla PDF a utilizar para notas crédito. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "signed" : false,							//[true si se va a firmar digitalmente la factura]
                  "send" : false,							//[true si se va a enviar a la DIAN]
                  "sendToCustomer" : false,						//[true si se va a enviar al cliente]
                  "notificationStrings" : ["EMAIL"],				//[Mecanismo de envío de la factura al cliente]
                  "description" :"descripción de la factura",			//[Descripción de la factura]
                  "currencyCode" :"COP",						//[Código de moneda]
                  "customer" : {
                  "personType" :1,							//[PERSONA_JURIDICA(1), PERSONA_NATURAL(2), GRAN_CONTRIBUYENTE(3)]
                  "personId" :"890903937",						//[No. de documento]
                  "idType" :31,							//[NIT(31), REGISTRO_CIVIL(11), TARJETA_DE_IDENTIDAD(12), CEDULA_DE_CIUDADANIA(13), TARJETA_DE_EXTRANJERIA(21), CEDULA_DE_EXTRANJERIA(22), PASAPORTE(41), DOCUMENTO_DE_IDENTIFICACION_EXTRANJERO(42), NUIP(91)]
                  "schemeType" :0,							//[REGIMEN_SIMPLIFICADO(0), REGIMEN_OTRO(1), REGIMEN_COMUN(2),REGIMEN_CLIENTE_EN_EL_EXTERIOR(-1)]
                  "address" :"CALLE 12 7 46",					//[Dirección del adquirente]
                  "city" :"Bogotá, D.C.",						//[Ciudad del adquirente]
                  "department" :"BOGOTÁ DC",					//[Departamento del adquirente]
                  "citySubDivision" :"",						//[Barrio o zona del adquirente]
                  "countryCode" :"CO",						//[Código del país]
                  "organizationName" :"BANCO COLPATRIA S.A.",			//[Razón social o nombre del adquirente]
                  "firstName" :"",							//[Primer nombre]
                  "middleName" :"",							//[Segundo nombre]
                  "lastName" :"",							//[Apellido]
                  "codePhoneNumber" :"",						//[Código telefónico del país. i.e. +57]
                  "cellPhone" :"",							//[Número celular]
                  "email" :"diego.bulla@software-colombia.com",			//[Correo electrónico]
                  "partyTaxSchema": ["O-13", "O-15", "O-23"]                    //Tipo de responsabilidad de acuerdo a la siguiente tabla
                  },
                  "lines" : [ {
                  "description" :"CERTIFICADO DE REGISTRO MINERO DIGITAL ",         //[Descripción del item facturado No. 1]
                  "quantity" : 1,							//[Cantidad del ítem facturado No. 1]
                  "currencyCode" :"COP",						//[Código de moneda]
                  "unityPrice" : 69000.00,						//[Precio unitario]
                  "noteLine" : null,						//[Observaciones]
                  "accountingCost" : null,						//[Centro de costo]
                  "totalPrice" : 69000.00,						//[Precio total]
                  "taxes" : [{
                  "taxAmount": 100000.0,						//[Base para el cálculo del impuesto]
                  "taxEvidenceType": false,                                         //[true: Impuesto retenido - false: Impuesto no retenido]
                  "taxableAmount": 19000.0,                                         //[Valor del impuesto]
                  "percent": 19.0,							//[Procentaje del impuesto]
                  "currencyCode": "COP",						//[Código de moneda]
                  "taxTypeCode": "01"						//[VALOR_TOTAL_DE_IVA("01"), VALOR_TOTAL_DE_IMPUESTO_AL_CONSUMO("02"), VALOR_TOTAL_DE_ICA("03"), VALOR_TOTAL_DE_IMPUESTO_NACIONAL_AL_CONSUMO("04")]
                  }] ,
                  },{
                  "description": "Esferos",
                  "quantity": 1,
                  "currencyCode": "COP",
                  "unityPrice": 120000.0,
                  "noteLine": null,
                  "accountingCost": null,
                  "totalPrice": 120000.0,
                  "taxes": []
                  }
                  ],
                  "extraWSProperties" : {
                  "Codigo" : "SM-40",                                               //[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Fecha" :"25/10/2018",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Caja" :"01 - PRINCIPAL",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Banco" :"BANCO DE BOGOTA",					//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Cuenta" :"000021980",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Recibo" :"CODIGO BARRAS",					//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Oficina" :"VENTAS PORTAL WEB - CODIGO BARRAS",                   //[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Num" :"20180815093337"						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  },
                  "amountNoTaxes" :69000.00,					//[Total de la factura sin impuestos]
                  "amountTaxes" :13110.00,						//[Total de impuestos]
                  "totalAmount" :82110.00,						//[Total de la factura con impuestos]
                  "totalAmountText" :"DOSCIENTOS DIEZ MIL DOSCIENTOS SETENTA Y NUEVE PESOS CON DIEZ Y OCHO CENTAVOS M/CTE.************" //[Texto Total de la factura con impuestos]
                  }
                 */
                /**
                 * Paso Produccion - 20190215
                  "idRange" de 174 A   85
                  "idInvoiceType" de  120 A 121
                  "signed" :  false  A  true
                  "send": false  A  true
                  "sendToCustomer" :  false  A  true
                  "username": adm_anm@yopmail.com   A   factura.electronica@anm.gov.co
                 */
                /*
                 * Incidente #14878
                  "idRange" de 174 A 135
                 */
                /** Incidente #15151 - 20191129
                  "idObject": "SETT27", De esta manera se debe enviar en ambiente de pruebas las facturas, puedes utilizar desde número SETT28.
                  "idVerificationDigit": "1", En este campo se debe agregar el dígito de verificación de los Nit cliente.
                  "city": "15244", El código de la ciudad debe estar alineado a los códigos brindados y que te adjunto nuevamente.
                  "department" :"91", El código de la departamento debe estar alineado a los códigos brindados y que te adjunto nuevamente.
                 */
                //Parametros de app.yml - 20191129
                $username = sfConfig::get('app_username');
                $password = sfConfig::get('app_password');
                $idRange = sfConfig::get('app_idRange');
                $idInvoiceType = sfConfig::get('app_idInvoiceType');
                $signed = sfConfig::get('app_signed');
                $send = sfConfig::get('app_send');
                $sendToCustomer = sfConfig::get('app_sendToCustomer');
                $idObjectPrefijo = sfConfig::get('app_idObjectPrefijo');

                /*
                 * Incidente #17555 - 20200604::LAVILA
                 * paymentMethod
                  Código: 1- Significado: Contado
                  Código: 2- Significado: Credito se debe envia la fecha paymentduedate
                 * paymentCode
                  Cuando son pagos por PSE
                  Código : 3 - Significado: Debito ACH
                  Cuando son pagos por Codigo de Barras
                  Código : 42 - Significado: Consignacion Bancaria.
                 */
                $paymentMethod = 1;
                $paymentCode = $value['payment_code'];


                //Pago de mas de un producto - 20200810::LAVILA
                $sql = <<<EOD
select
tab0.id_factura,
                        
upper(produc.descripcion) as producto,
prod.valor_uni_bruto,
prod.valor_uni_iva,  
prod.valor_uni_total,          
prod.valor_uni_bruto - prod.valor_uni_iva as valorsiniva_uni,          
prod.cantidad as cantidad,
prod.por_iva as por_iva,

produc.codigo
                        
from ca_factura_abaco tab0

left join ca_factura_pos pos
on pos.id_factura = tab0.id_factura

left join ca_factura_prod prod
on pos.id_factura = prod.id_factura

left join ca_producto produc
on produc.id_producto = prod.id_producto

where
tab0.estado_abaco = 0 
and tab0.id_factura is not null 
$whereFactura 

order by
produc.codigo                 
EOD;

                //ejecuta el sql
                $resultado_prod = CN_TABLE::executeSQL($sql);
                $lineas = '';
                $tag_prod = false;
                foreach ($resultado_prod as $value_prod) {

                    $producto = $value_prod['producto'];
                    $por_iva = $value_prod['por_iva'];
                    $valor_uni_bruto = $value_prod['valor_uni_bruto'];
                    $valor_uni_iva = $value_prod['valor_uni_iva'];
                    $valor_uni_total = $value_prod['valor_uni_total'];
                    //valores por cantidad - 20200625
                    $valorsiniva_uni = $value_prod['valorsiniva_uni'];
                    $quantity = $value_prod['cantidad'];
                    $valorsiniva_unicant = $valorsiniva_uni * $quantity;
                    $valor_uni_iva_cant = $valor_uni_iva * $quantity;

                    /**
                     * Campo de impuesto IVA - 20200625::LAVILA
                     */
                    $json_taxes = "";
                    if ($por_iva > 0) {
                        $json_taxes = <<<EOD

                            {
				"taxAmount": $valor_uni_iva_cant,
				"taxEvidenceType": false,
				"taxableAmount": $valorsiniva_unicant,
				"percent": $por_iva.0,
                                "taxTypeCode": "01"
                            }
EOD;
                    }

                    if ($tag_prod) {
                        $lineas .= ",";
                    } else {
                        $tag_prod = true;
                    }


                    $lineas .= <<<EOD
{
		"description" :"$producto",
		"quantity" : $quantity, 
		"currencyCode" :"COP",
		"unityPrice" : $valorsiniva_uni,
		"noteLine" : null,
		"accountingCost" : null,
		"totalPrice" : $valorsiniva_unicant,
		"taxes" : [
                            $json_taxes
                        ]
		}
EOD;
                }


                /**
                 * Incidente #18203 - 20200806::LAVILA
                 * 
                 * "partyTaxSchema": ["O-13", "O-15", "O-23"]
                 * tipo_responsabilidad = O-13;O-15;O-23 o por defecto R-99-PN
                 */
                $partyTaxSchema = $value['codigo_dian'];


                $json_clave = <<<EOD
{
	"username" : "$username",
	"password" : "$password",
EOD;
                $json_cuerpo = <<<EOD
	"objectType" :0,
	"invoiceIdType" :1,
	"idRange" :$idRange,
	"idObject" :"$idObjectPrefijo$sec_factura",
	"idInvoiceType" :$idInvoiceType,
	"idNoteType" : null,
	"signed" : $signed,
	"send" : $send,
	"sendToCustomer" : $sendToCustomer,
	"notificationStrings" : ["EMAIL"],
	"description" :"$observaciones",
	"currencyCode" :"COP",
	"paymentMethod" :"$paymentMethod",
	"paymentCode" :"$paymentCode",
	"customer" : {
		"personType" :$id_tip_ter,
		"personId" :"$num_doc",
		"idType" :$id_tipo_doc,
		"idVerificationDigit" :"$dv",
		"schemeType" :0,
		"address" :"$direccion",
		"city" :"$codmun_text",
		"department" :"$coddepto",
		"citySubDivision" :"",
		"countryCode" :"CO",
		"organizationName" :"$razon_soc",
		"firstName" :"$pnombre",
		"middleName" :"$snombre",
		"lastName" :"$papellido",
		"codePhoneNumber" :"",
		"cellPhone" :"$tel",
		"email" :"$mail",
                "partyTaxSchema": [$partyTaxSchema]
	},
	"lines" : [ 
		$lineas
	],
	"extraWSProperties" : {
		"Codigo" : "$codigo",
		"Fecha" :"$fecha_facturacion",
		"Caja" :"$caja",
		"Banco" :"$banco",
		"Cuenta" :"$cuenta",
		"Recibo" :"$tipo_pago",
		"Oficina" :"$oficina",
		"Num" :"$pin"
	},
	"amountNoTaxes" :$valorsiniva,
	"amountTaxes" :$valor_iva,
	"totalAmount" :$valor_total,
	"totalAmountText" :"$valor_total_text M/CTE.************"
}
EOD;
                //Json de envio
                //Separa JSON por clave visible en log - 20191120
                $json = <<<EOD
$json_clave
$json_cuerpo                        
EOD;
                //echo $json;
                //die();
                $this->custom_logger->info("---Formato Json de envio:" . $json_cuerpo);
                $this->logMessage("---Formato Json de envio:" . $json_cuerpo);

                //Ejemplo Json simple
                //$data = array("name" => "Hagrid", "age" => "36");
                //$data_string = json_encode($data);
                $data_string = $json;

                /**
                 * Llamado CURL
                 */
                $ch = curl_init($url_abaco);
                //Parametros de retorno en cURL
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Content-Length: ' . strlen($data_string))
                );
                //Ejecuta la petición
                $respuesta = curl_exec($ch);
                //$respuesta = "";
                $this->custom_logger->info("[webservie_sigm_factura_abaco] respuesta: " . $respuesta . ".\n");
                $this->logMessage("[webservie_sigm_factura_abaco] respuesta: " . $respuesta);
                //Error CURL
                if ($respuesta === false) {
                    $message = curl_error($ch);
                    //echo $message;
                } elseif (count($respuesta) <= 0) {
                    $this->logMessage("[webservie_sigm_factura_abaco] Sin respuesta.");
                    $message = "Sin respuesta.";
                }
                //Se cierra la conexión
                curl_close($ch);
                //die();
                //echo $respuesta;
                $arrayRespuesta = json_decode($respuesta, true);
                //print_r($arrayRespuesta);
                //die();
                //valida que esten las variables en la respuesta
                $this->logMessage("************Valida que esten las variables en la respuesta************");
                //if (isset($arrayRespuesta['idInvoice']) && isset($arrayRespuesta['message'])) {
                //if (true) {
                $pos = strpos($respuesta, 'idInvoice');
                $pos2 = strpos($respuesta, 'message');
                if ($pos !== false && $pos2 !== false) {

                    $this->logMessage("Si vienen variables en la respuesta de llamadoAbaco.");

                    $idInvoice = $arrayRespuesta['idInvoice'];
                    $message = $arrayRespuesta['message'];
                    $message = str_replace("'", "'|| chr(39) ||'", $message);
                    $successful = $arrayRespuesta['successful'];
                    if (isset($arrayRespuesta['idrequest'])) {
                        $idrequest = $arrayRespuesta['idrequest'];
                    } else {
                        $idrequest = '';
                    }

                    //valida successful
                    if ($successful == 'true') {
                        $successful = 'true';
                        $estado_abaco = '1';
                        $fecha_abaco = 'sysdate';
                    } else {
                        $successful = 'false';
                        $estado_abaco = '0';
                        $fecha_abaco = 'null';
                    }

                    //actualizar registro de CA_FACTURA_ABACO   
                    //set idinvoice = nvl('$idInvoice',idinvoice),se quida texto solo guarda numeros - 20191202 
                    $sql = <<<EOD
update CA_FACTURA_ABACO
set idinvoice = nvl(  translate( '$idInvoice','QWERTYUIOPASDFGHJKLÑZXCVBNMqwertyuiopasdfghjklñzxcvbnm','0')  ,idinvoice),
message = '$message',
successful_txt = '$successful',
idrequest = '$idrequest',
estado_abaco = '$estado_abaco',
fecha_abaco = $fecha_abaco
where
id_factura = $id_factura
and estado_abaco = 0        
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                } else {

                    $this->logMessage("No vienen variables en la respuesta de llamadoAbaco.");
                }
            }

            //die();
            /**
             * Incidente #10372, Llamado a servicio envio correo ABACO - 20181114
             */
            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'INICIO LLAMADO ENVIO CORREO ABACO'";
            //$this->custom_logger->info("[webservie_sigm_factura_abaco] " . $observacion . ".\n");
            //CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);
            //$this->llamadoCorreoAbaco($id_factura);
            //$this->logMessage("[webservie_sigm_factura_abaco] Fin llamado a servicio envio correo ABACO.");


            $this->custom_logger->info("----------------------------------------FIN llamadoAbaco");
            $this->logMessage("----------------------------------------FIN llamadoAbaco");

            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();
            //die();

            $array_abaco = array(
                'message' => $message,
                'successful' => $successful,
                'idRequest' => $idrequest,
                'idinvoice' => $idInvoice
            );

            return $array_abaco;
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $mensaje = "ERROR!!!";

            $this->logMessage($mensaje);
            $this->custom_logger->info("[webservie_sigm_factura_abaco] Exception:: " . $mensaje);
            $this->logMessage("state");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());


            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            $observacion = "'Se termino el proceso de factura_portal_abaco llamadoAbaco, se generaron errores en el proceso de creación...'";
            $this->custom_logger->info("[webservie_sigm_factura_abaco] Exception:: " . $observacion . ".\n");

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

            $this->conn->commit();

            $this->custom_logger->info("----------------------------------------FIN Exception llamadoAbaco");
            $this->logMessage("----------------------------------------FIN Exception llamadoAbaco");


            $array_abaco = array(
                'message' => "Message " . $e->getMessage(),
                'successful' => 'false',
                'idRequest' => '',
                'idinvoice' => ''
            );

            return $array_abaco;
        }
    }

}
